; This AutoIt script takes a directory listing from a windows directory and creates an alphabetical XML list of the images.

#include <File.au3>
#include <Array.au3>
Local $Quote=Chr(34)
Local $CRLF=Chr(13) & Chr(10)
Local $TAB=Chr(9)
Local $Images[1]
Local $Extensions[5]=["*.jpg","*.jpeg","*.png","*.tif","*.bmp"]
For $i=0 to UBound($Extensions)-1
	Local $FileList=_FileListToArray(".",$Extensions[$i],1)
	For $j=UBound($FileList)-1 to 1 Step -1
		_ArrayAdd($Images,$FileList[$j])
	Next
Next
_ArrayReverse($Images)
_ArrayPop($Images)


Local $FileHandle=FileOpen("_imagelist.xml",2)
FileWrite($FileHandle,"<?xml version=" & $Quote & "1.0" & $Quote & " encoding=" & $Quote & "UTF-8" & $Quote & "?>" & $CRLF)
FileWrite($FileHandle,$TAB & "<Images>" & $CRLF)
For $Counter=1 to UBound($Images)
	FileWrite($FileHandle,$TAB & $TAB & "<filename index=" & $Quote & $Counter & $Quote & ">" & $Images[$Counter-1] & "</filename>" & $CRLF)
Next
FileWrite($FileHandle,$TAB & "</Images>" & $CRLF)
FileClose($FileHandle)
MsgBox(0,"Done.","Kaleidoscope Image List (_imagelist.xml) has been created.")